import "./style.css";
import { reactive as B, computed as F, onActivated as z, watch as P, ref as H, resolveComponent as m, openBlock as Y, createBlock as j, withCtx as w, createVNode as p, normalizeClass as J, createElementVNode as h, toDisplayString as K, withDirectives as M, vShow as k } from "vue";
import { Grid as Q, GridColumn as W } from "@opentiny/vue";
import { PluginPanel as X, SvgButton as Z } from "@opentiny/tiny-engine-common";
import { constants as $ } from "@opentiny/tiny-engine-utils";
import { iconEyeopen as ee, iconEyeclose as te, IconChevronDown as oe } from "@opentiny/vue-icon";
import { useCanvas as ne, useResource as re, useLayout as G } from "@opentiny/tiny-engine-controller";
import { extend as ce } from "@opentiny/vue-renderless/common/object";
import { typeOf as se } from "@opentiny/vue-renderless/common/type";
import { getSchema as q, getRenderer as ie, clearSelect as ae, hoverNode as le, selectNode as de } from "@opentiny/tiny-engine-canvas";
const ue = (r, i) => {
  const d = r.__vccOpts || r;
  for (const [o, _] of i)
    d[o] = _;
  return d;
}, { PAGE_STATUS: D } = $, ge = {
  components: {
    TinyGrid: Q,
    TinyGridColumn: W,
    PluginPanel: X,
    SvgButton: Z,
    IconEyeopen: ee(),
    IconEyeclose: te()
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup() {
    const { pageState: r, getInstance: i } = ne(), { getMaterial: d } = re(), o = (e) => {
      const c = (s) => (s.forEach((l) => {
        l.show = r.nodesStatus[l.id] !== !1;
        const f = l.children;
        se(f) !== "array" ? delete l.children : l.children.length && c(l.children);
      }), s);
      return [{ ...c([ce(!0, {}, e)])[0], componentName: "body" }];
    }, { PLUGIN_NAME: _ } = G(), t = B({
      pageSchema: [],
      expandAll: !0,
      initSchema: [],
      isLock: F(
        () => ![D.Occupy, D.Guest].includes(G().layoutState.pageStatus.state)
      ),
      dragState: {
        allowDrop: !0,
        dragSchema: null,
        hoverVm: null,
        currentVm: null,
        parentNode: null,
        indicator: !0
      }
    });
    z(() => {
      t.pageSchema = o(q());
    }), P(
      () => r.currentSchema,
      () => {
        t.pageSchema = o(q());
      }
    );
    const v = () => {
      t.expandAll = !t.expandAll;
    }, N = (e) => {
      e.show = !e.show, r.nodesStatus[e.id] = e.show, ie().setCondition(e.id, e.show), ae();
    }, b = (e) => e.componentName ? d(e.componentName).icon || "IconAssociation" : void 0, x = (e, c) => {
      if (t.isLock)
        return;
      le(e.id);
      const s = c.target.querySelector(".tree-handle");
      s && (s.style.display = "block");
    }, I = (e, c) => {
      e && !e.show || (c.target.querySelector(".tree-handle").style.display = "none");
    }, A = (e) => {
      t.isLock || de(e == null ? void 0 : e.id, "clickTree");
    }, n = H(null), u = () => {
    }, a = ({ row: e }) => {
      var s;
      return "nav-tree " + (((s = r == null ? void 0 : r.currentSchema) == null ? void 0 : s.id) === e.id ? "high-light-node" : "");
    }, O = (e, c) => {
      var E;
      e.dragged.classList.remove("nodrag");
      const { clientY: s } = c, l = e.draggedRect.bottom, f = Math.abs(s - l), L = e.dragged.querySelector(".tree-box").getAttribute("type"), R = e.dragged.querySelector(".tree-box").getAttribute("schemaId"), y = i(R);
      t.dragState.dragSchema = y;
      const T = e.related.querySelector(".tree-box").getAttribute("type"), U = e.related.querySelector(".tree-box").getAttribute("schemaId"), g = i(U);
      r.hoverVm = g;
      const S = (E = y == null ? void 0 : y.componentName) == null ? void 0 : E.container, V = g == null ? void 0 : g.parent.schema.componentName;
      L === "col" && S && T !== "col" || L === "col" && !S && V !== "row" || L !== "col" && S && T === "row" ? t.dragState.indicator = !1 : g ? t.dragState.indicator = !0 : t.dragState.indicator = !1, t.dragState.indicator ? (e.dragged.classList.remove("nodrag"), t.dragState.allowDrop = !0) : (e.dragged.classList.add("nodrag"), t.dragState.allowDrop = !1);
      const C = c.target;
      f < 4 && f > 1 && S && (!g.schema.children || g.schema.children.length === 0) && (t.dragState.parentNode = C, C.querySelector(".tiny-grid-tree-wrapper").innerHTML = '<i class="tiny-grid-tree__node-btn tiny-grid-icon__caret-right"></i>'), t.dragState.parentNode && t.dragState.parentNode.getAttribute("data-rowid") !== C.getAttribute("data-rowid") && (t.dragState.parentNode.querySelector(".tiny-grid-tree-wrapper").innerHTML = "", t.dragState.parentNode = null);
    };
    return P(
      () => r.isLock,
      (e) => {
        setTimeout(u, 1e3), t.isLock = e;
      }
    ), {
      checkElement: A,
      mouseover: x,
      mouseleave: I,
      showNode: N,
      state: t,
      getIcon: b,
      rowDropMove: O,
      gridRef: n,
      toggleTree: v,
      getClassName: a,
      PLUGIN_NAME: _,
      renderIconFn: (e, { isActive: c }) => e(oe(), {
        class: ["tiny-grid-tree__node-btn", { is__active: c }]
      })
    };
  }
}, me = { class: "tree-wrap lowcode-scrollbar" }, pe = ["schemaId", "type", "onMouseover", "onMouseleave", "onClick"], he = { class: "tree-content" }, _e = ["onMouseup"];
function fe(r, i, d, o, _, t) {
  const v = m("svg-button"), N = m("icon-eyeopen"), b = m("icon-eyeclose"), x = m("tiny-grid-column"), I = m("tiny-grid"), A = m("plugin-panel");
  return Y(), j(A, {
    class: "outlinebox",
    title: "大纲树",
    onClose: i[1] || (i[1] = (n) => r.$emit("close"))
  }, {
    header: w(() => {
      var n, u;
      return [
        p(v, {
          class: J(["item icon-sidebar", [((n = d.fixedPanels) == null ? void 0 : n.includes(o.PLUGIN_NAME.OutlineTree)) && "active"]]),
          tips: (u = d.fixedPanels) != null && u.includes(o.PLUGIN_NAME.OutlineTree) ? "解除固定面板" : "固定面板",
          onClick: i[0] || (i[0] = (a) => r.$emit("fixPanel", o.PLUGIN_NAME.OutlineTree)),
          name: "fixed"
        }, null, 8, ["class", "tips"])
      ];
    }),
    content: w(() => [
      h("div", me, [
        p(I, {
          ref: "gridRef",
          data: o.state.pageSchema,
          "tree-config": { children: "children", expandAll: o.state.expandAll, renderIcon: o.renderIconFn },
          "show-header": !1,
          "highlight-hover-row": !1,
          "auto-resize": !0,
          "row-class-name": o.getClassName
        }, {
          default: w(() => [
            p(x, {
              field: "componentName",
              "tree-node": ""
            }, {
              default: w((n) => {
                var u;
                return [
                  h("span", {
                    class: "tree-box",
                    schemaId: (u = n.row) == null ? void 0 : u.id,
                    type: n.row.componentName,
                    onMouseover: (a) => o.mouseover(n.row, a),
                    onMouseleave: (a) => o.mouseleave(n.row, a),
                    onClick: (a) => o.checkElement(n.row)
                  }, [
                    h("span", he, [
                      h("span", null, K(n.row.componentName), 1)
                    ]),
                    M(h("span", {
                      class: "tree-handle",
                      onMouseup: (a) => o.showNode(n.row)
                    }, [
                      M(p(N, null, null, 512), [
                        [k, !n.row.show]
                      ]),
                      M(p(b, null, null, 512), [
                        [k, n.row.show]
                      ])
                    ], 40, _e), [
                      [k, !n.row.show]
                    ])
                  ], 40, pe)
                ];
              }),
              _: 1
            })
          ]),
          _: 1
        }, 8, ["data", "tree-config", "row-class-name"])
      ])
    ]),
    _: 1
  });
}
const ye = /* @__PURE__ */ ue(ge, [["render", fe], ["__scopeId", "data-v-11188f8a"]]), ke = {
  id: "OutlineTree",
  title: "大纲树",
  icon: "plugin-icon-tree",
  align: "top",
  component: ye
};
export {
  ke as default
};
